<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>eRPC Generator (erpcgen): SearchPath.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
<link href="customdoxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eRPC Generator (erpcgen)
   &#160;<span id="projectnumber">Rev. 1.4.0</span>
   </div>
   <div id="projectbrief">NXP Semiconductors</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_search_path_8h_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">SearchPath.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright (c) 2014-2016, Freescale Semiconductor, Inc.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> * Copyright 2016 NXP</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * All rights reserved.</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * Redistribution and use in source and binary forms, with or without modification,</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> * are permitted provided that the following conditions are met:</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> * o Redistributions of source code must retain the above copyright notice, this list</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> *   of conditions and the following disclaimer.</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * o Redistributions in binary form must reproduce the above copyright notice, this</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *   list of conditions and the following disclaimer in the documentation and/or</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *   other materials provided with the distribution.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> * o Neither the name of the copyright holder nor the names of its</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *   contributors may be used to endorse or promote products derived from this</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *   software without specific prior written permission.</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS &quot;AS IS&quot; AND</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"> * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"> * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="comment"> * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="comment"> * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="preprocessor">#if !defined(_searchpath_h_)</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="preprocessor">#define _searchpath_h_</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="preprocessor">#include &lt;list&gt;</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="comment">// Classes</span></div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00044"></a><span class="lineno"><a class="line" href="class_path_searcher.html">   44</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_path_searcher.html">PathSearcher</a></div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;{</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="keyword">enum</span> _target_type</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    {</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        kFindFile,</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        kFindDirectory</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    };</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">enum</span> _target_type target_type_t;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="keyword">protected</span>:</div><div class="line"><a name="l00059"></a><span class="lineno"><a class="line" href="class_path_searcher.html#a8bf0b820c7cccbdda02214ca626e9ac5">   59</a></span>&#160;    <span class="keyword">static</span> <a class="code" href="class_path_searcher.html">PathSearcher</a> *<a class="code" href="class_path_searcher.html#a8bf0b820c7cccbdda02214ca626e9ac5">s_searcher</a>;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <span class="keyword">static</span> <a class="code" href="class_path_searcher.html">PathSearcher</a> &amp;<a class="code" href="class_path_searcher.html#a2d808911bacf77ecb43afd7f3de08a8e">getGlobalSearcher</a>();</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00067"></a><span class="lineno"><a class="line" href="class_path_searcher.html#a0a2b1157faa1145b87258e65b7c2d8df">   67</a></span>&#160;    <a class="code" href="class_path_searcher.html#a0a2b1157faa1145b87258e65b7c2d8df">PathSearcher</a>() {}</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_path_searcher.html#af9554bf75313b8d268db3b642e0c4008">addSearchPath</a>(<span class="keyword">const</span> std::string &amp;path);</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_path_searcher.html#adae60e58362ae0098ffdc8fbf1b9e007">setTempPath</a>(<span class="keyword">const</span> std::string &amp;path);</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_path_searcher.html#a32c8f23e9994995e464722ea07bd0529">search</a>(<span class="keyword">const</span> std::string &amp;base, target_type_t targetType, <span class="keywordtype">bool</span> searchCwd, std::string &amp;result);</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;<span class="keyword">protected</span>:</div><div class="line"><a name="l00079"></a><span class="lineno"><a class="line" href="class_path_searcher.html#a63744c70ba23ec6b7ba57e8cc6ea2fea">   79</a></span>&#160;    <span class="keyword">typedef</span> std::list&lt;std::string&gt; <a class="code" href="class_path_searcher.html#a63744c70ba23ec6b7ba57e8cc6ea2fea">string_list_t</a>; </div><div class="line"><a name="l00080"></a><span class="lineno"><a class="line" href="class_path_searcher.html#a7a90afcb04c4b53f299123b969afea4f">   80</a></span>&#160;    string_list_t <a class="code" href="class_path_searcher.html#a7a90afcb04c4b53f299123b969afea4f">m_paths</a>;                        </div><div class="line"><a name="l00081"></a><span class="lineno"><a class="line" href="class_path_searcher.html#af0457aa7e4e966a830a60bda2c106139">   81</a></span>&#160;    std::string <a class="code" href="class_path_searcher.html#af0457aa7e4e966a830a60bda2c106139">m_tempPath</a>;                       </div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_path_searcher.html#a5d9ed7d522f86c5c9f28ee392859215d">isAbsolute</a>(<span class="keyword">const</span> std::string &amp;path);</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    std::string <a class="code" href="class_path_searcher.html#ae28b10bb9bf2c700244a9e1b17f7d1e3">joinPaths</a>(<span class="keyword">const</span> std::string &amp;first, <span class="keyword">const</span> std::string &amp;second);</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;};</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;<span class="preprocessor">#endif // _searchpath_h_</span></div><div class="ttc" id="class_path_searcher_html_af0457aa7e4e966a830a60bda2c106139"><div class="ttname"><a href="class_path_searcher.html#af0457aa7e4e966a830a60bda2c106139">PathSearcher::m_tempPath</a></div><div class="ttdeci">std::string m_tempPath</div><div class="ttdoc">Possibility to add temporary path. </div><div class="ttdef"><b>Definition:</b> SearchPath.h:81</div></div>
<div class="ttc" id="class_path_searcher_html_a2d808911bacf77ecb43afd7f3de08a8e"><div class="ttname"><a href="class_path_searcher.html#a2d808911bacf77ecb43afd7f3de08a8e">PathSearcher::getGlobalSearcher</a></div><div class="ttdeci">static PathSearcher &amp; getGlobalSearcher()</div><div class="ttdoc">Access global path searching object. </div><div class="ttdef"><b>Definition:</b> SearchPath.cpp:51</div></div>
<div class="ttc" id="class_path_searcher_html_af9554bf75313b8d268db3b642e0c4008"><div class="ttname"><a href="class_path_searcher.html#af9554bf75313b8d268db3b642e0c4008">PathSearcher::addSearchPath</a></div><div class="ttdeci">void addSearchPath(const std::string &amp;path)</div><div class="ttdoc">Add a new search path to the end of the list. </div><div class="ttdef"><b>Definition:</b> SearchPath.cpp:61</div></div>
<div class="ttc" id="class_path_searcher_html_a32c8f23e9994995e464722ea07bd0529"><div class="ttname"><a href="class_path_searcher.html#a32c8f23e9994995e464722ea07bd0529">PathSearcher::search</a></div><div class="ttdeci">bool search(const std::string &amp;base, target_type_t targetType, bool searchCwd, std::string &amp;result)</div><div class="ttdoc">Attempts to locate a file by using the search paths. </div><div class="ttdef"><b>Definition:</b> SearchPath.cpp:87</div></div>
<div class="ttc" id="class_path_searcher_html_adae60e58362ae0098ffdc8fbf1b9e007"><div class="ttname"><a href="class_path_searcher.html#adae60e58362ae0098ffdc8fbf1b9e007">PathSearcher::setTempPath</a></div><div class="ttdeci">void setTempPath(const std::string &amp;path)</div><div class="ttdoc">Set temporary path. </div><div class="ttdef"><b>Definition:</b> SearchPath.cpp:66</div></div>
<div class="ttc" id="class_path_searcher_html_a5d9ed7d522f86c5c9f28ee392859215d"><div class="ttname"><a href="class_path_searcher.html#a5d9ed7d522f86c5c9f28ee392859215d">PathSearcher::isAbsolute</a></div><div class="ttdeci">bool isAbsolute(const std::string &amp;path)</div><div class="ttdoc">Returns whether path is absolute. </div><div class="ttdef"><b>Definition:</b> SearchPath.cpp:142</div></div>
<div class="ttc" id="class_path_searcher_html_a63744c70ba23ec6b7ba57e8cc6ea2fea"><div class="ttname"><a href="class_path_searcher.html#a63744c70ba23ec6b7ba57e8cc6ea2fea">PathSearcher::string_list_t</a></div><div class="ttdeci">std::list&lt; std::string &gt; string_list_t</div><div class="ttdoc">Linked list of strings. </div><div class="ttdef"><b>Definition:</b> SearchPath.h:79</div></div>
<div class="ttc" id="class_path_searcher_html_ae28b10bb9bf2c700244a9e1b17f7d1e3"><div class="ttname"><a href="class_path_searcher.html#ae28b10bb9bf2c700244a9e1b17f7d1e3">PathSearcher::joinPaths</a></div><div class="ttdeci">std::string joinPaths(const std::string &amp;first, const std::string &amp;second)</div><div class="ttdoc">Combines two paths into a single one. </div><div class="ttdef"><b>Definition:</b> SearchPath.cpp:151</div></div>
<div class="ttc" id="class_path_searcher_html_a7a90afcb04c4b53f299123b969afea4f"><div class="ttname"><a href="class_path_searcher.html#a7a90afcb04c4b53f299123b969afea4f">PathSearcher::m_paths</a></div><div class="ttdeci">string_list_t m_paths</div><div class="ttdoc">Ordered list of paths to search. </div><div class="ttdef"><b>Definition:</b> SearchPath.h:80</div></div>
<div class="ttc" id="class_path_searcher_html"><div class="ttname"><a href="class_path_searcher.html">PathSearcher</a></div><div class="ttdoc">Handles searching a list of paths for a file. </div><div class="ttdef"><b>Definition:</b> SearchPath.h:44</div></div>
<div class="ttc" id="class_path_searcher_html_a0a2b1157faa1145b87258e65b7c2d8df"><div class="ttname"><a href="class_path_searcher.html#a0a2b1157faa1145b87258e65b7c2d8df">PathSearcher::PathSearcher</a></div><div class="ttdeci">PathSearcher()</div><div class="ttdoc">Constructor. </div><div class="ttdef"><b>Definition:</b> SearchPath.h:67</div></div>
<div class="ttc" id="class_path_searcher_html_a8bf0b820c7cccbdda02214ca626e9ac5"><div class="ttname"><a href="class_path_searcher.html#a8bf0b820c7cccbdda02214ca626e9ac5">PathSearcher::s_searcher</a></div><div class="ttdeci">static PathSearcher * s_searcher</div><div class="ttdoc">Global search object singleton. </div><div class="ttdef"><b>Definition:</b> SearchPath.h:59</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- HTML footer for doxygen 1.8.5-->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul class="foot">
    <li class="footer">&copy; 2016 NXP Semiconductors. All rights reserved.
    </li>
  </ul>
</div>
</body>
</html>
